interface DataStoreOptions {
    redis: {
        url: string;
        password?: string;
        db: number;
    };
    namespace: string;
    encryptionPassword?: string;
    expirationMs: number;
    idLength?: number;
}
declare class EphemeralStore {
    private redisClient;
    private ttl;
    private encryptor;
    private idLength?;
    constructor(options: DataStoreOptions);
    save(value: string, customId?: string): Promise<string>;
    get(id: string): Promise<string>;
}

export { DataStoreOptions, EphemeralStore };
