"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  EphemeralStore: () => EphemeralStore
});
module.exports = __toCommonJS(src_exports);
var import_nanoid = require("nanoid");

// src/helpers/encryption.ts
var import_string_crypto = __toESM(require("string-crypto"));
var Encryptor = class {
  constructor(password) {
    this.cryptor = new import_string_crypto.default();
    this.password = password;
  }
  encryptString(str) {
    return this.cryptor.encryptString(str, this.password);
  }
  decryptString(str) {
    return this.cryptor.decryptString(str, this.password);
  }
};

// src/helpers/redis.ts
var import_core = __toESM(require("@keyvhq/core"));
var import_redis = __toESM(require("@keyvhq/redis"));
function createRedisClient(redisConfig, namespace) {
  const cache = new import_redis.default(redisConfig.url, {
    password: redisConfig.password,
    db: redisConfig.db ?? 0
  });
  return new import_core.default({
    store: cache,
    namespace
  });
}

// src/index.ts
var EphemeralStore = class {
  constructor(options) {
    this.redisClient = createRedisClient({
      url: options.redis.url,
      password: options.redis.password,
      db: options.redis.db
    }, options.namespace);
    this.ttl = options.expirationMs;
    this.encryptor = new Encryptor(options.encryptionPassword ?? "");
    this.idLength = options.idLength;
  }
  async save(value, customId) {
    const id = customId ?? (0, import_nanoid.nanoid)(this.idLength);
    await this.redisClient.set(id, this.encryptor.encryptString(value), this.ttl);
    return id;
  }
  async get(id) {
    const stored = await this.redisClient.get(id);
    return this.encryptor.decryptString(stored);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  EphemeralStore
});
